/* Problem URL: https://codeforces.com/contest/2131/problem/F */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        ll n;
        cin >> n;

        string at, bt;
        cin >> at >> bt;

        vi a(n);
        vi b(n);

        rep(i, n) {
            a[i] = at[i] - '0';
            b[i] = bt[i] - '0';
        }

        vl minimal(n * 2 + 2);
        vl count(n * 2 + 2);

        int middle = n;
        vi bc(2);

        rep(i, n) {
            bc[b[i]]++;

            int diff = bc[0] - bc[1];

            minimal[middle + diff] += min(bc[0], bc[1]);
            count[middle + diff]++;
        }

        nrep(i, 2, n + 1) {
            minimal[middle + i] += minimal[middle + i - 1];
            minimal[middle - i] += minimal[middle - i + 1];
            count[middle + i] += count[middle + i - 1];
            count[middle - i] += count[middle - i + 1];
        }

        vl ac(2);
        ll ans = 0;

        rep(i, n) {
            ac[a[i]]++;

            int diff = ac[1] - ac[0];

            ans += minimal[middle + diff] + count[middle + diff] * min(ac[1], ac[0]);
        }

        cout << ans << '\n';
    }
}
